/*
 * Copyright (C) 2013 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 *
 * IO.h - This file is part of BCov
 *
 * BCov is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BCov is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BCov; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 */

#ifndef IO_H_
#define IO_H_
#include <stdio.h>
#include "align.h"

void fail(char *errstr);
void printe(char *errstr);
void print_verbose(char *msgstr, int verbose, int required);
void usage();
double ** readbinarymat(char * filename, unsigned int * l);
double ** readmat(char * filename, unsigned int * l);
pair * readss(char * filename, unsigned int * ns, unsigned int * maxlen);
void write_problem(FILE * ofp, double ** H, unsigned int n);
void print_acc(double ** R, double ** P, unsigned int l, unsigned int tnbase);
void print_matrix(entry **M, unsigned int x, unsigned int y);

#endif /* IO_H_ */
