/*
 * Copyright (C) 2013 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 *
 * align.h - This file is part of BCov
 *
 * BCov is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BCov is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BCov; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 */

#ifndef ALIGN_H_
#define ALIGN_H_

#define MAXBULGES 0
#define DIAG 1
#define UP 2
#define LEFT 3
#define GAP -10
#define GAPP -10000000
#define PARALLEL 0
#define ANTIPARALLEL 1
#define BRIDGE 2
#define GLOBAL 0
#define LOCAL 1
//#define MIXED 2
#define MAXOV 2
#define BE 0
#define BB 1


typedef struct pair {
	int i;
	int j;
} pair;

typedef struct alignment {
	double score;
	int size;
	pair * pairs;
} alignment;

typedef struct entry {
	unsigned int d;
	unsigned int gaps;
	unsigned int matches;
	double score;
} entry;

void align_strands(alignment * res, double ** S, unsigned int n, unsigned int m, unsigned int maxgaps, unsigned int type);
void copyaln(alignment * dest, alignment * source);

#endif /* ALIGN_H_ */
