/*
 * Copyright (C) 2013 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 *
 * mem.c - This file is part of BCov
 *
 * BCov is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BCov is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BCov; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 */

#include "IO.h"
#include "mem.h"


/* Allocate matrix */
void * allocmat(int rows, int columns, int size)
{
    int             i;
    void          **p, *rp;

    rp = malloc(rows * sizeof(void *) + sizeof(int));

    *((int *)rp) = rows;
    p = rp + sizeof(int);
    for (i = 0; i < rows; i++)
        p[i] = calloc(columns, size);

    return p;
}

/* Allocate Fortran compatible square matrix */
void *f_matrix_calloc(int ndim, int size)
{
    void *p;

    p = calloc(ndim * ndim, size);

    if (p == NULL)
    	fail("f_matrix_calloc: calloc failed!");

    return p;
}

/* Allocate vector */
void *allocvec(int columns, int size)
{
    void *p;
    p = calloc(columns, size);
    return p;
}


/* Free matrix */
void freemat(void *rp)
{
    int rows;
    void **p = rp;
    rows = *((int *)(rp - sizeof(int)));
    while (rows--)
        free(p[rows]);
    free(rp - sizeof(int));
}

void freealn(alignment * aln) {
	free(aln->pairs);
	free(aln);
}

