/*
 * Copyright (C) 2013 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 *
 * psicov.h - This file is part of BCov
 *
 * BCov is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BCov is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BCov; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 */

#ifndef SCE_H_
#define SCE_H_

#define FALSE 0
#define TRUE 1

#define SQR(x) ((x)*(x))
#define MAX(x,y) ((x)>(y)?(x):(y))
#define MIN(x,y) ((x)<(y)?(x):(y))

#define MAXSEQLEN 5000
#define MINEFSEQS 0

#define RHO 1e-3
#define APPROXFLG 1
#define SHRINKFLG 1
#define RAWSCFLG 1
#define FILTFLG 0
#define APCFLG 1
#define TARGFNZERO 0.0
#define THRESH 1e-4
#define IDTHRESH -1
#define PSEUDOC 1
#define MINSEQSEP 3
#define MAXGAPF 0.9

typedef struct psicov_args {
	int approxflg;
	int shrinkflg;
	int rawscflg;
	int filtflg;
	int apcflg;
	int pseudoc;
	int minseqsep;
	double rhodefault;
	double targfnzero;
	double thresh;
	double idthresh;
	double maxgapf;
} psicov_args;

void psicov_init(psicov_args * pargs);

double ** psicov_sce(char * filename, psicov_args * pargs, char * blockfn, unsigned int * l);

double ** psicov_compute_profile(char * filename, double idthresh, int pseudoc);

#endif /* SCE_H_ */
